// CreateMacro.h: interface for the CCreateMacro class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CREATEMACRO_H__A3A8EAD3_8613_421C_91EA_2603E58930D4__INCLUDED_)
#define AFX_CREATEMACRO_H__A3A8EAD3_8613_421C_91EA_2603E58930D4__INCLUDED_

#include "Interpreter.h"	// Added by ClassView

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CCreateMacro  
{
public:
	CCreateMacro();
	virtual ~CCreateMacro();

    void __stdcall CCreateMacro::CreateMacro(
            const CString &strText);

    ushort __stdcall CCreateMacro::ConvertToMegaCadBlock( // R: Anzahl Zeilen
            const CString &strText,
            TCHAR   **ppszBlock,                     // wird allokiert
            bool    bAddMagic = false);              // true --> Zeile "Magic: 42734571" vorweg

    ushort __stdcall CCreateMacro::CreateMegaCadBlocks( // R: Anzahl Zeilen
            const CString &strDbInfo,
            TCHAR   **ppszBlockText,
            TCHAR   **ppszBlockDbInfo);

protected:
	CInterpreter m_Interpreter;

};

#endif // !defined(AFX_CREATEMACRO_H__A3A8EAD3_8613_421C_91EA_2603E58930D4__INCLUDED_)
