/////////////////////////////////////////////////////////////////////////////

#if !defined(TYPES_H_INCLUDED)
#define TYPES_H_INCLUDED

typedef enum FieldType_t
{
    Date,
    Time,
    FileName,
    UserName,
} FieldType_t;

typedef enum TimeType_t
{
    Current,
    Created,
    Modified,
    Accessed,
    Name
} TimeType_t;

typedef struct Field_t
{
    TCHAR        szField[48];
    FieldType_t  iType;
    TimeType_t   iTimeType;
    const TCHAR  *pszMacroText;
} Field_t;

/////////////////////////////////////////////////////////////////////////////
#endif
/////////////////////////////////////////////////////////////////////////////
